;	TITLE (C) ROT TFT ROT STEPPER	         8/7/2016
;	adding stepper motor control via spare output 18/6/2016
;	NOTES
;	Earths Mag Feild is 0.3 to 0.6 Gauss
	
;-----------------------------------------------------------------------------
       .equ __30F4012, 1
       .include "p30f4012.inc"
;-----------------------------------------------------------------------------
;	       		28 PIN DIL 
;			dsPIC30F4012
;               	 ______  ______
;			    	|      \/      |
;  PROGRAMER/MCLR --+ 1         28 +-- RB7  AVdd	
;		            |              |
;         PB1/RB0 --+ 2         27 +-- RB6  AVss
;	     	        |              |
;         PB2/RB1 --+ 3         26 +-- RE0/SCL         MAG SENSOR		
;	    	        |              |
;       P SCK/RB2 --+ 4         25 +-- RE1/SDA IN/OUT  MAG SENSOR
;	    	        |              |
;        MISO/RB3 --+ 5         24 +-- RE2/CE1	  
;	         	    |              |
;  	   P MOSI/RB4 --+ 6         23 +-- RE3/CE0
;	   		        |              |
;         IRQ/RB5 --+ 7         22 +-- RE4/RST
;	        	    |              |
;             VSS  -+ 8         21 +-- RE5/DC
;	          	    |              |
;             OSC --+ 9         20 +-- VDD
;	          	    |              |
;            RC15 --+ 10        19 +-- VSS
;	           	    |              |
;	         RC13 --+ 11        18 +-- RC7/PGC	
;	          	    |              |
;   T1_TICKS RC14 --+ 12        17 +-- RC6/PGD
;	         	    |              |
;             VDD --+ 13        16 +-- RE8
;	          	    |              |
;     STEPPER/RD1 --+ 14        15 +-- RD0	       	
;                   |______________|

;--------------------------------------------------------------
;Configuration bits:
	config __FOSC, CSW_FSCM_OFF & FRC_PLL16
	config __FWDT,WDT_OFF
	config __PBORPOR_OFF, PBOR_OFF & MCLR_EN
	config __FGS, CODE_PROT_OFF
;..............................................................................
;Program Specific Constants (literals used in code)
;..............................................................................
;-------------- global declarations ---------------------------------------
	.global __reset
	.global __SoftResetBaro
;..............................................................................
;Constants stored in Program space
;..............................................................................
        .section .myconstbuffer, psv
;------ general Constants -----------------------------
;define constant
;PORTB
	.equ	PB1,#0
	.equ	PB2,#1
	.equ	SCLK,2
	.equ	MISO,3
	.equ	MOSI,4
	.equ	IRQ,5
;PORTC
	.equ	TIMER,14
;PORTD
	.equ	OUT1,#1
;PORTE
	.equ	SCL,0
	.equ	SDA,1
	.equ	CE1,2
	.equ	CE0,3
	.equ	RST,4
	.equ	DC,5
;---- Useful Colours ---------------------------------------------------
	.equ	BLACK,  0x0000	;	
	.equ	BROWN,	0x7880	;
	.equ	RED,    0xF800	;
	.equ	ORANGE,	0xE380	;	
	.equ    YELLOW, 0xFFE0	;
	.equ    GREEN,  0x07E0	;
	.equ    BLUE,   0x001F	;
	.equ	VIOLET, 0xF8FF	;
	.equ	GREY,	0xCCC0 	;
	.equ    WHITE,  0xFFFF	;  	
;------ I/O Port constants -----------------------------
;define ram assignments
		.bss	saved,2
		.bss	T1_Ticks,2
		.bss	count,2
		.bss	temp,2
		.bss	temp1,2
		.bss	temp2,2
		.bss	temp3,2	
		.bss	temp4,2
		.bss	temp5,2
		.bss	datbuff,2
	    .bss    Hx,2
	   	.bss    Hy,2
	   	.bss    Hz,2
		.bss	rl0,2
		.bss	rl1,2
		.bss	test,2
		.bss	digit1,2
		.bss	digit2,2
		.bss	digit3,2
		.bss	digit4,2
		.bss	digit5,2
		.bss	digit6,2	
		.bss	preangle,2	
		.bss	angle,2
		.bss	prevangle,2
		.bss	preanglelast,2
		.bss	touchflg,2	
		.equ	delay1,2	
		.bss	pre1,2
		.bss	pre2,2
		.bss	pre3,2	
		.bss	pre4,2
		.bss	pre5,2
		.bss	pre6,2
		.bss	pre7,2	
		.bss	pre8,2	
		.bss	rlyflg,2	
		.bss	AC1,2
		.bss	AC2,2	
		.bss	AC3,2
		.bss	AC4,2	
		.bss	AC5,2
		.bss	AC6,2
		.bss	B1,2
		.bss	B2,2
		.bss	B3,2
		.bss	B4,2
		.bss	B5,2
		.bss	B6,2
		.bss	B7,2
		.bss	MB,2
		.bss	MC,2	
		.bss	MD,2
		.bss	UT,2	
		.bss	UP,2
		.bss	X1,2
		.bss	X2,2
		.bss	TEMP,2
		.bss	PRESSURE,2
		.bss	slowspeed,2	
		.bss	y1,2
		.bss	y2,2
		.bss	y3,2
		.bss	y4,2
		.bss	y5,2
		.bss	y6,2
		.bss	x1,2
		.bss	x2,2
		.bss	x3,2
		.bss	x4,2
		.bss	x5,2
		.bss	x6,2
		.bss	yy,2
		.bss	yyyy,2
;------------------------- vector tables ----------------
		.global __reset
		.global	__T1Interrupt
;-------------------------------------------------------
	.text	;start of code
;-----------------------------------------	
__T1Interrupt:
		call	buttons
		bclr	IFS0,#T1IF
		com		T1_Ticks
		nop
		btst	T1_Ticks,#0
		bra		z,bbb
		bclr	LATC,#14	
		retfie
bbb:
		bset	LATC,#14
		retfie
;-----------------------------------------
__reset:
	mov 	#__SP_init, W15       	;Initalize the Stack Pointer
	mov 	#__SPLIM_init, W0     	;Initialize the Stack Pointer Limit Register
	mov 	W0, SPLIM
	nop                             ;Add NOP to follow SPLIM initialization
	mov     #0xffff,w0
	mov     w0,ADPCFG
	clr     LATB
	clr     LATC
	clr     LATD
	clr     LATE
	bset    CORCON, #PSV            ;Enable Program Space Visibility
;----------------------- Initialisation Routine -----------------------
init:
	rcall	init_ports
	rcall	init_timer	
   	rcall   InitialiseTouch
	rcall	InitialiseLCD
	rcall	InitMag
	clr     angle
	clr		preangle
	clr		preanglelast
	clr		rlyflg
	clr		digit4
	clr		digit5
	clr		digit6
	clr		touchflg
	call	InitialiseTouch
	mov		#0,w0
	mov		w0,y1
	mov		#0,w0
	mov		w0,y2
	mov		#0,w0
	mov		w0,y3
	mov		#0,w0
	mov		w0,y4
	mov		#0,w0
	mov		w0,y5
	mov		#0,w0
	mov		w0,y6
;-------------------- set up routines -----------------
    ;Draw Background Colour
   	mov   	#BLACK,w8	  				
	rcall   DrawBackground	
 ;Draw Red Preset Box
	mov     #RED,W8
	mov     #440,W9		;Line StartX
	mov     #280,W10	;Line StartY
	mov     #490,W11	;Line EndX
	mov     #320,W12	;Line EndY
	rcall   DrawFilledRectangle
 ;Draw Green Preset Box		
	mov     #GREEN,W8
	mov     #440,W9		;Line StartX
	mov     #240,W10	;Line StartY
	mov     #490,W11	;Line EndX
	mov     #280,W12	;Line EndY
	rcall   DrawFilledRectangle
  ;Draw Blue Preset Box		
	mov     #BLUE,W8
	mov     #440,W9		;Line StartX
	mov     #200,W10	;Line StartY
	mov     #490,W11	;Line EndX
	mov     #240,W12	;Line EndY
	rcall   DrawFilledRectangle
  ;Draw Yellow Preset Box					
	mov     #YELLOW,W8
	mov     #440,W9		;Line StartX
	mov     #160,W10	;Line StartY
	mov     #490,W11	;Line EndX
	mov     #200,W12	;Line EndY
	rcall   DrawFilledRectangle
 ;Draw White Preset Box
	mov     #WHITE,W8
	mov     #440,W9		;Line StartX
	mov     #120,W10	;Line StartY
	mov     #490,W11	;Line EndX
	mov     #160,W12	;Line EndY
	rcall   DrawFilledRectangle
 ;Draw Violet Preset Box					
	mov     #VIOLET,W8
	mov     #440,W9		;Line StartX
	mov     #80,W10		;Line StartY
	mov     #490,W11	;Line EndX
	mov     #120,W12	;Line EndY
	rcall   DrawFilledRectangle
 ;Draw Brown Preset Box			
	mov     #BROWN,W8
	mov     #440,W9		;Line StartX
	mov     #040,W10	;Line StartY
	mov     #490,W11	;Line EndX
	mov     #80,W12		;Line EndY
	rcall   DrawFilledRectangle
 ;Draw Orange Preset Box	
	mov     #ORANGE,W8
	mov     #440,W9		;Line StartX
	mov     #000,W10	;Line StartY
	mov     #490,W11	;Line EndX
	mov     #40,W12		;Line EndY
	rcall   DrawFilledRectangle
;--------------------------------------------						
	mov 	#BLACK,W7	;North
	mov		#YELLOW,W8
	mov		#230,W9		;X
	mov		#270,W10	;Y	
	mov		#0x4e,w11
	rcall	DrawFilledBigText
	mov 	#BLACK,W7	;South
	mov		#230,W9		;X
	mov		#70,W10		
	mov		#0x53,w11
	rcall	DrawFilledBigText
	mov 	#BLACK,W7	;East
	mov		#340,W9		;X
	mov		#170,W10		
	mov		#0x45,w11
	rcall	DrawFilledBigText
	mov 	#BLACK,W7	;West
	mov		#125,W9		;X
	mov		#170,W10		
	mov		#0x57,w11
	rcall	DrawFilledBigText
	call	read_mag
	goto	main
;----------------------------------------------------
rx_mag:
	call	rx_time		;get X values
    sl      W0,#8,W0
    mov     W0,Hx
    call	ACK_back
	call	rx_time
    ior     Hx
  	call	ACK_back  
	call	rx_time		;get Z values
	mov		w0,yy
    sl      W0,#8,W0
    mov     W0,Hz
    call	ACK_back	
	call	rx_time
	mov		w0,yyyy
    ior     Hz
   	call	ACK_back 	
	call	rx_time		;get Y values
	mov		w0,yy
    sl      W0,#8,W0
    mov     W0,Hy
    call	ACK_back	
	call	rx_time
    ior     Hy
 	call	NACK_back   	
	return
;------------------ receive clock data --------
rx_time:
	mov		#0x08,w0
	mov		w0,temp3
	clr		temp4
rx_data:
	sl		temp4
	bclr	temp4,#0
	btsc	PORTE,#SDA	;MSB first
	bset	temp4,#0
	call	i2c_clk
	dec		temp3
	bra		nz,rx_data
	mov		temp4,w0	
	return
;------------------------ ACKNOWLEDGE --------------------------
NACK_back:
	bset	LATE,#SDA
	call	i2c_clk
	bset	LATE,#SDA		
	return
ACK_back:
	bclr	LATE,#SDA
	call	i2c_clk
	bset	LATE,#SDA	
	return
;--------------------------------------------------------------------
main:
	call	read_mag
;	call	TouchTest		
	bra		main
;--------------------------------------------------------
buttons:
	btss	PORTB,#PB1
	goto	forward
	nop
	btss	PORTB,#PB2
	goto	reverse
	nop
	return
forward: 
	bset	LATD,#OUT1
	repeat	#2000
	nop
	bclr	LATD,#OUT1	
	repeat	#2000
	nop
	return
reverse: 
	bclr	LATD,#OUT1
	repeat	#2000
	nop
	bset	LATD,#OUT1
	repeat	#2000
	nop
	return
;-------------------------------------------------------------------	
read_mag:		
    ;Read Magnetic Sensor
	call	start_i2c	
	mov		#0x3C,w0	;control write
	mov		w0,datbuff
	call	sendmag		
	mov		#0x03,w0
	mov		w0,datbuff
	call	sendmag		
	call	stop_i2c
	call	start_i2c	
	mov		#0x3D,w0	;control read
	mov		w0,datbuff
	call	sendmag		
    call	rx_mag      
	call	stop_i2c
    ;Convert Magnetic Sensor Field Strengths to Heading (0 to +359 degrees)
   	mov     Hx,W4
   	mov     Hz,W5
   	call    CalcHeading
   	mov     W0,angle
	mov		#100,w2
	repeat	#17
	div.u	w0,w2
	mov		w0,digit1
	mov		#10,w2
	repeat	#17
	div.u	w1,w2
	mov		w0,digit2
	mov		w1,digit3
 ;Draw Digits in YELLOW on BLACK
   	mov 	#BLACK,W7
	mov		#YELLOW,W8
	mov		#190,W9		;X
	mov		#230,W10	
	mov		digit1,W11
	add		#0x30,w11
	rcall	DrawFilledBigText
	mov		#230,W9
	mov		digit2,W11
	add		#0x30,w11	
	rcall	DrawFilledBigText
	mov		#270,W9
	mov		digit3,W11
	add		#0x30,w11
	rcall	DrawFilledBigText
	   ;UnDraw Yellow Circle to Black
	mov     #BLACK,W8		;Colour
	mov		preangle,w0
	mov		#-360,w1
	sub		w1,w0,w0
	mov		#270,w1
	sub		w0,w1,w0	
	mov		#140,w1
	mov		#240,w2
	mov		#160,w3
	call	CalcPolarPoint	
	mov     w4,W9		;XC
	mov     w5,W10		;XY
	mov     #5,W11		;Radious
	rcall   DrawFilledCircle
	call	Grat
	mov		angle,w0
	mov		w0,preangle
;-------------------------------------------
    ;Draw Yellow Circle dot
	mov     #YELLOW,W8		;Colour
	mov		angle,w0
	mov		#-360,w1
	sub		w1,w0,w0
	mov		#270,w1
	sub		w0,w1,w0	
	mov		#140,w1
	mov		#240,w2
	mov		#160,w3
	call	CalcPolarPoint	
	mov     w4,W9		;XC
	mov     w5,W10		;XY
	mov     #5,W11		;Radious
	rcall   DrawFilledCircle	
	return	
;------------------------------------------------
Grat:
 ;Draw Graticule Lines every 10 degrees
	mov     #-180,W0        ;Start Angle (-180 degrees)
1:	mov     #155,W1         ;Outer Radius
	mov     #240,W2         ;Centre X
	mov     #160,W3         ;Centre Y
	rcall   CalcPolarPoint  ;Convert to X,Y Point
	mov     W4,W9           ;Line StartX
	mov     W5,W10          ;Line StartY
	mov     #120,W1          ;Inner Radius
	rcall   CalcPolarPoint  ;Convert to X,Y Point
	mov     W4,W11          ;Line EndX
	mov     W5,W12          ;Line EndY
	mov     #WHITE,W8       ;Line Colour
	rcall   DrawLine        ;Draw Line
	add     W0,#10,W0       ;Increment Angle by 10 degrees
	mov     #180,W1         ;Have we reaced +180 degrees
	cp      W0,W1           ;
	bra     nz,1b           ;No: Loop
	return
;-----------------------------------------------
TouchTest:
	return
	bset	LATE,#CE0
	bclr	LATE,#CE1
	call	ReadTouch       ;Read Touch Position
	cp0     W0             ;Is Pressed?
	bra     n,1f           ;no so branch
	mov		w0,temp1
	sub		w0,#0x1b0		;is it preset position
	bra		n,2f			;no so branch
	mov		w1,preangle		;get "Y" axis
;	call	predigits
2:	mov		temp1,w0
	sub		w0,#60
	bra		gt,1f
	bclr	LATE,#CE0
	bset	LATE,#CE1		
	return                  ; Return	
1:
	bclr	LATE,#CE0
	bset	LATE,#CE1		
	return                  ; Return	
;-------------------------------------------------
InitMag:
	bclr	TRISE,#SDA
	bset	LATE,#SCL
	bset	LATE,#SDA
	;Wait 6ms 
	mov		#0,W0
	mov		#10,W1
1:	sub		W0,#1,W0
	subb	W1,#0,W1
	bra		nz,1b
	call	start_i2c
	mov		#0x3C,w0	;data start position
	mov		w0,datbuff
	call	sendmag	
	mov		#0x02,w0	;mode register
	mov		w0,datbuff
	call	sendmag	
	mov		#0x00,w0
	mov		w0,datbuff
	call	sendmag	
	call	stop_i2c
	;Wait 6ms 
	mov		#10,W1
pp:
	sub		W0,#1,W0
	subb	W1,#0,W1
	bra		nz,pp
	call	start_i2c
	mov		#0x3C,w0	;data start position
	mov		w0,datbuff
	call	sendmag	
	mov		#0x01,w0	;set gain to min
	mov		w0,datbuff
	call	sendmag	
	mov		#0x20,w0
	mov		w0,datbuff
	call	sendmag	
	call	stop_i2c
	call	start_i2c
	mov		#0x3C,w0	;data start position
	mov		w0,datbuff
	call	sendmag	
	mov		#0x00,w0	;set gain to min
	mov		w0,datbuff
	call	sendmag	
	mov		#0x10,w0
	mov		w0,datbuff
	call	sendmag	
	call	stop_i2c
	;Wait 6ms 
	mov		#10,W1
ppp:
	sub		W0,#1,W0
	subb	W1,#0,W1
	bra		nz,ppp
	return
;---------------------------------
sendmag:
	mov		datbuff,w0	;saved data
send_LCD:
	mov		w0,temp2	;this will get destroyed
	mov		#0x08,w0	;send 8 bits
	mov		w0,temp1
send8_i2c:
	mov		LATE,w0
	mov		w0,temp3
	bclr	temp3,#SDA
	btsc	temp2,#0x07
	bset	temp3,#SDA	;set data bit	
	mov		temp3,w0
	mov		w0,LATE
	sl		temp2	
	call	i2c_clk
	dec		temp1
	bra		nz,send8_i2c
	bset	LATE,#SDA
	call	i2c_clk				
	return
;----------------------
start_i2c:
start_LCD:
	bclr	LATE,#SDA
	call	I2C_dly
	bclr	LATE,#SCL	;LCD start condition
	call	I2C_dly
	return
;----------------------
stop_i2c:
	bset	LATE,#SDA
	call	I2C_dly
	bset	LATE,#SCL
	call	I2C_dly
	bset	LATE,#SDA	;LCD stop condition
	call	I2C_dly
	return
;---------------------------------------------------------
i2c_clk:
	call	I2C_dly
	bset	LATE,#SCL
	call	I2C_dly
	bclr	LATE,#SCL	;LCD clock pulse
	call	I2C_dly
	return   
;--------------------------- SET UP PORTS -----------------
init_timer:
	bclr	LATC,#14
	clr		T1_Ticks
	clr		T1CON
	clr		TMR1
	mov		#0x04ff,w0	;this sets stepper speed
	mov		w0,PR1

	bset	IPC0,#T1IP0	
	bclr	IPC0,#T1IP1	
	bclr	IPC0,#T1IP2
	
	bclr	IFS0,#T1IF
	bset	IEC0,#T1IE		
	bset	T1CON,#TON	;set TON
	bset	T1CON,#4	;settimer prescaler to DIV by 256
	bset	T1CON,#5
	return
;--------------------------------------------------------
init_ports:
	clr     PTCON
	clr     PWMCON1
	clr     OVDCON
	clr     LATB
	clr     LATD
	clr		LATC
	clr		LATE
	mov     #0x2b,w0	;0=output 1=input
	mov     w0,TRISB
	mov     #0x00,w0
	mov     w0,TRISC
	mov     #0x00,w0
	mov     w0,TRISD
	mov     #0x00,w0
	mov.w    w0,TRISE
	
	bset	CNPU1,#2 		;input pull-ups RB0
	bset	CNPU1,#3 		;input pull-ups RB1

	bset	LATE,#CE0
	bset	LATE,#CE1
	bset	LATE,#RST	;reset hardware
	bset	LATE,#DC
	bset	LATE,#SDA
	return
;------------------------- small delay ------------------
I2C_dly:
	repeat #1000
	nop
	return
;-------------- RESTORE --------
restore:
	call	index1
	TBLRDL	[w0],w4
;	mov	w4,setpoint

	call	index2
	TBLRDL	[w0],w4
	return
;------------ SAVE DATA TO EEPROM -----------
erase:
	mov	w0,NVMADR
	mov	w1,NVMADRU
	mov	#0x4044,w0
	mov	w0,NVMCON
	call	key
	return
;---------------------- 
save_ee1:
	call	index1
	call	erase
	call	index1
;	mov	setpoint,w2
	TBLWTL	w2,[w0]
	mov	#0x4004,w0
	mov	w0,NVMCON
	call	key
	return
;------------------ SAVE ONE WORD IN EERPOM -------------
key:
	DISI	#5
	mov	#0x55,w0
	mov	w0,NVMKEY
	mov	#0xaa,w1
	mov	w1,NVMKEY
	bset	NVMCON,#WR
notdone:
	btsc	NVMCON,#WR	
	bra	notdone
	return
;-------------------- EEPROM BOTTOM ADDRESS  (0X7FFC00)-------------------------
index1:
	mov	#0xfc00,w0
	mov	#0x7f,w1
	mov	w1,TBLPAG
	return
;-------------------- EEPROM BOTTOM ADDRESS  (0X7FFC02)-------------------------
index2:
	mov	#0xfc02,w0
	mov	#0x7f,w1
	mov	w1,TBLPAG
	return
;-------------------- EEPROM BOTTOM ADDRESS  (0X7FFC00)-------------------------
index:
	mov	#0xfc00,w0
	mov	#0x7f,w1
	mov	w1,TBLPAG
	return
;----------------------- MENU SET TEXT ----------
strings:
.ascii	"           "

;------------------------ end of program ---------------------

	.end		

